Subject: Issues with very large packets

From: John Goerzen <[email-masked]>
Date: Thu, 18 Feb 2021 15:35:52 -0600

Hi folks!

So this week I had the occasion to send some 250GB packets through 
NNCP.  This generally worked in the end, but had two interesting 
foibles along the way.

First, nncp-stat was extremely slow on a system that had packets 
like that queued for transmission.  I'm wondering if it is trying 
to read all the packets, even when called with no parameters?

The other is a new twist on the timeout problem I mentioned 
previously.  I previously encountered it post-receive when the 
receiving end would do a time-consuming check on a largeish (say, 
10GB) packet.

With these very large packets, I also encountered it at the 
beginning of a call.  nncp-daemon on the transmitting side 
apparently was taking too long at call establishment, and 
nncp-call would timeout (with the same error I'd mentioned 
previously) without receiving anything.  Interestingly, if 
nncp-call would try again immediately, it would work.  By cycling 
through this timeout/working/timeout/working pattern, eventually 
all the data was transmitted.

It makes me wonder if nncp-daemon was doing some sort of expensive 
scan at the beginning of the call, and either it or the OS cached 
the results?  Not quite sure there.

Anyhow, thanks again!

- John